org.jboss.netty.handler.traffic

## Class ChannelTrafficShapingHandler

- java.lang.Object
- - org.jboss.netty.channel.SimpleChannelHandler
  - - org.jboss.netty.handler.traffic.AbstractTrafficShapingHandler
    - - org.jboss.netty.handler.traffic.ChannelTrafficShapingHandler

- All Implemented Interfaces:
    ChannelDownstreamHandler, ChannelHandler, ChannelUpstreamHandler, ExternalResourceReleasable

      public class ChannelTrafficShapingHandler
      extends AbstractTrafficShapingHandler

  This implementation of the `AbstractTrafficShapingHandler` is for channel traffic shaping, that is to say a per channel limitation of the bandwidth.
  The general use should be as follow:
  - Add in your pipeline a new ChannelTrafficShapingHandler, before a recommended `ExecutionHandler` (like `OrderedMemoryAwareThreadPoolExecutor` or `MemoryAwareThreadPoolExecutor`).
    `ChannelTrafficShapingHandler myHandler = new ChannelTrafficShapingHandler(timer);`
    timer could be created using `HashedWheelTimer`
    `pipeline.addLast("CHANNEL_TRAFFIC_SHAPING", myHandler);`
    Note that this handler has a Pipeline Coverage of "one" which means a new handler must be created for each new channel as the counter cannot be shared among all channels. For instance, if you have a `ChannelPipelineFactory`, you should create a new ChannelTrafficShapingHandler in this `ChannelPipelineFactory` each time getPipeline() method is called.
    Other arguments can be passed like write or read limitation (in bytes/s where 0 means no limitation) or the check interval (in millisecond) that represents the delay between two computations of the bandwidth and so the call back of the doAccounting method (0 means no accounting at all).
    A value of 0 means no accounting for checkInterval. If you need traffic shaping but no such accounting, it is recommended to set a positive value, even if it is high since the precision of the Traffic Shaping depends on the period where the traffic is computed. The highest the interval, the less precise the traffic shaping will be. It is suggested as higher value something close to 5 or 10 minutes.
  - When you shutdown your application, release all the external resources (except the timer internal itself) by calling:
    `myHandler.releaseExternalResources();`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.jboss.netty.channel.ChannelHandler

      `ChannelHandler.Sharable`

  - ### Field Summary

    - ### Fields inherited from class org.jboss.netty.handler.traffic.AbstractTrafficShapingHandler

      `checkInterval, DEFAULT_CHECK_INTERVAL, timer, trafficCounter`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ChannelTrafficShapingHandler(ObjectSizeEstimator objectSizeEstimator, Timer timer)`
    `ChannelTrafficShapingHandler(ObjectSizeEstimator objectSizeEstimator, Timer timer, long checkInterval)`
    `ChannelTrafficShapingHandler(ObjectSizeEstimator objectSizeEstimator, Timer timer, long writeLimit, long readLimit)`
    `ChannelTrafficShapingHandler(ObjectSizeEstimator objectSizeEstimator, Timer timer, long writeLimit, long readLimit, long checkInterval)`
    `ChannelTrafficShapingHandler(Timer timer)`
    `ChannelTrafficShapingHandler(Timer timer, long checkInterval)`
    `ChannelTrafficShapingHandler(Timer timer, long writeLimit, long readLimit)`
    `ChannelTrafficShapingHandler(Timer timer, long writeLimit, long readLimit, long checkInterval)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `channelClosed(ChannelHandlerContext ctx, ChannelStateEvent e)` Invoked when a `Channel` was closed and all its related resources were released.
    `void` | `channelConnected(ChannelHandlerContext ctx, ChannelStateEvent e)` Invoked when a `Channel` is open, bound to a local address, and connected to a remote address.

    - ### Methods inherited from class org.jboss.netty.handler.traffic.AbstractTrafficShapingHandler

      `configure, configure, configure, doAccounting, getTrafficCounter, handleDownstream, messageReceived, releaseExternalResources, toString, writeRequested`

    - ### Methods inherited from class org.jboss.netty.channel.SimpleChannelHandler

      `bindRequested, channelBound, channelDisconnected, channelInterestChanged, channelOpen, channelUnbound, childChannelClosed, childChannelOpen, closeRequested, connectRequested, disconnectRequested, exceptionCaught, handleUpstream, setInterestOpsRequested, unbindRequested, writeComplete`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ChannelTrafficShapingHandler

          public ChannelTrafficShapingHandler(Timer timer,
                                      long writeLimit,
                                      long readLimit,
                                      long checkInterval)

    - #### ChannelTrafficShapingHandler

          public ChannelTrafficShapingHandler(Timer timer,
                                      long writeLimit,
                                      long readLimit)

    - #### ChannelTrafficShapingHandler

          public ChannelTrafficShapingHandler(Timer timer,
                                      long checkInterval)

    - #### ChannelTrafficShapingHandler

          public ChannelTrafficShapingHandler(Timer timer)

    - #### ChannelTrafficShapingHandler

          public ChannelTrafficShapingHandler(ObjectSizeEstimator objectSizeEstimator,
                                      Timer timer,
                                      long writeLimit,
                                      long readLimit,
                                      long checkInterval)

    - #### ChannelTrafficShapingHandler

          public ChannelTrafficShapingHandler(ObjectSizeEstimator objectSizeEstimator,
                                      Timer timer,
                                      long writeLimit,
                                      long readLimit)

    - #### ChannelTrafficShapingHandler

          public ChannelTrafficShapingHandler(ObjectSizeEstimator objectSizeEstimator,
                                      Timer timer,
                                      long checkInterval)

    - #### ChannelTrafficShapingHandler

          public ChannelTrafficShapingHandler(ObjectSizeEstimator objectSizeEstimator,
                                      Timer timer)

  - ### Method Detail

    - #### channelClosed

          public void channelClosed(ChannelHandlerContext ctx,
                           ChannelStateEvent e)
                             throws Exception

      Description copied from class: `SimpleChannelHandler`
      Invoked when a `Channel` was closed and all its related resources were released.
      Overrides:
        `channelClosed` in class `SimpleChannelHandler`
      Throws:
        `Exception`

    - #### channelConnected

          public void channelConnected(ChannelHandlerContext ctx,
                              ChannelStateEvent e)
                                throws Exception

      Description copied from class: `SimpleChannelHandler`
      Invoked when a `Channel` is open, bound to a local address, and connected to a remote address.
      Overrides:
        `channelConnected` in class `SimpleChannelHandler`
      Throws:
        `Exception`

Copyright © 2008-2012 The Netty Project. All Rights Reserved.